/* 
 * <LIC_AMD_STD>
 * Copyright <2000-2010> ADVANCED MICRO DEVICES, INC. All Rights Reserved.
 *    
 *    
 * Unless otherwise designated in writing, this software and any related 
 * documentation are the confidential proprietary information of AMD. 
 *   
 * THESE MATERIALS ARE PROVIDED "AS IS" WITHOUT ANY UNLESS OTHERWISE 
 * NOTED IN WRITING, EXPRESS OR IMPLIED WARRANTY OF ANY KIND, INCLUDING 
 * BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NONINFRINGEMENT, 
 * TITLE, FITNESS FOR ANY PARTICULAR PURPOSE AND IN NO EVENT SHALL AMD 
 * OR ITS LICENSORS BE LIABLE FOR ANY DAMAGES WHATSOEVER. 
 *   
 * AMD does not assume any responsibility for any errors which may appear 
 * in the Materials nor any responsibility to support or update the Materials.  
 * AMD retains the right to modify the Materials at any time, without notice, 
 * and is not obligated to provide such modified Materials to you. AMD is 
 * not obligated to furnish, support, or make any further information 
 * available to you.
 * 
 * </LIC_AMD_STD>  
 * <CTL_AMD_STD>
 * </CTL_AMD_STD>  
 * <DOC_AMD_STD>
 * </DOC_AMD_STD>  
 */

#ifndef __OS_INC_H__
#define __OS_INC_H__

//
//   OS-Specific includes
//

#include "wdm.h"
 
#define DURAUDIO_DEBUG		TRUE
//#define PCI_WATCHER_DEBUG		TRUE

//
//		DMA Buffer constants
//

//
//	Base address of the DMA buffers.
//	IMPORTANT: This address is fixed!  
//	make sure it is not being used by any other device
//
#define AUDIO_DMA_BUFFER_BASE_PA				0x0007C000 
//
#define AUDIO_DMA_BUFFER_SIZE                   8192
#define AUDIO_DMA_CHANNELS                      2
#define AUDIO_DMA_PAGE_SIZE                     2048
#define AUDIO_DMA_PAGES                         (AUDIO_DMA_BUFFER_SIZE / AUDIO_DMA_PAGE_SIZE)

#define	SIZE_OF_EACH_PRD_BLOCK		64			//  Each PRD entry will point to 64 bytes (16 samples) of the DMA buffer

//---------------------------
//		  OS-Specific
//---------------------------

void			OS_DbgMsg				( unsigned char *szFormat, ... );

unsigned long	OS_ReadPortULong		(unsigned short Port);
unsigned short	OS_ReadPortUShort		(unsigned short Port);
void			OS_WritePortULong		(unsigned short Port, unsigned long  Data);
void			OS_WritePortUShort		(unsigned short Port, unsigned short Data);

unsigned char	OS_ReadPortUChar		(unsigned short Port);
void			OS_WritePortUChar		(unsigned short Port, unsigned char Data);

void*			OS_AllocateMemory		(unsigned long Size);
void*			OS_AllocateDMAMemory	(void* pAdapterObject, unsigned long Size, unsigned long *PhysicalAddress);
void			OS_FreeDMAMemory		(void* pAdapterObject, void* VirtualAddress, unsigned long PhysicalAddress, unsigned long Size);

unsigned long	OS_VirtualAddress		(unsigned long PhysAddress);
void			OS_Free_VirtualAddress	(unsigned long VirtualAddress);
unsigned long	OS_Get_F3BAR0_Virt		(unsigned long BAR_Phys);
void			OS_Free_F3BAR0_Virt		(unsigned long VirtualAddress);
void			OS_Free					(PVOID pucBuff);
void			OS_Sleep				(unsigned long Delay);

unsigned char	OS_CopyFromUser			(unsigned char *DMABuffer,  unsigned char *UserBuffer, unsigned long Count);
unsigned char	OS_CopyToUser			(unsigned char *UserBuffer, unsigned char *DMABuffer,  unsigned long Count);

void			OS_InitSpinLock (void);
void			OS_SpinLock		();
void			OS_SpinUnlock	();

//#include <wdm.h>
#include <stdarg.h>
#include <stdio.h>


#endif	//  __OS_INC_H__

